#ifndef __X11UTIL_H
#define __X11UTIL_H

#include "ttxssh.h"

typedef struct _X11AuthData {
  char FAR * local_protocol;
  unsigned char FAR * local_data;
  int local_data_len;
  char FAR * spoofed_protocol;
  unsigned char FAR * spoofed_data;
  int spoofed_data_len;
} X11AuthData;

#define X11_get_spoofed_protocol_name(d) ((d)->spoofed_protocol)
#define X11_get_spoofed_protocol_data(d) ((d)->spoofed_data)
#define X11_get_spoofed_protocol_data_len(d) ((d)->spoofed_data_len)

void X11_get_DISPLAY_info(char FAR * name_buf, int name_buf_len, int FAR * port);
X11AuthData FAR * X11_load_local_auth_data(int screen_num);
void FAR * X11_init_unspoofing_filter(struct _TInstVar FAR * pvar,
  X11AuthData FAR * auth_data);
int X11_unspoofing_filter(void FAR * closure, int direction,
  int FAR * length, unsigned char FAR * FAR * buf);
void X11_dispose_auth_data(X11AuthData FAR * auth_data);

#endif
